#include <wx/string.h>

const wxString GPL_TEXT() { return
wxT(R"(<h3 style="text-align: center;">GNU GENERAL PUBLIC LICENSE</h3>)")
wxT(R"(<p style="text-align: center;">Version 3, 29 June 2007</p>)")
wxT(R"(<p>Copyright &copy; 2007 Free Software Foundation, Inc.)")
wxT(R"( &lt;<a href="https://fsf.org/">https://fsf.org/</a>&gt;</p><p>)")
wxT(R"( Everyone is permitted to copy and distribute verbatim copies)")
wxT(R"( of this license document, but changing it is not allowed.</p>)")
wxT(R"(<h4 id="preamble">Preamble</h4>)")
wxT(R"(<p>The GNU General Public License is a free, copyleft license for)")
wxT(R"(software and other kinds of works.</p>)")
wxT(R"(<p>The licenses for most software and other practical works are designed)")
wxT(R"(to take away your freedom to share and change the works.  By contrast,)")
wxT(R"(the GNU General Public License is intended to guarantee your freedom to)")
wxT(R"(share and change all versions of a program--to make sure it remains free)")
wxT(R"(software for all its users.  We, the Free Software Foundation, use the)")
wxT(R"(GNU General Public License for most of our software; it applies also to)")
wxT(R"(any other work released this way by its authors.  You can apply it to)")
wxT(R"(your programs, too.</p>)")
wxT(R"(<p>When we speak of free software, we are referring to freedom, not)")
wxT(R"(price.  Our General Public Licenses are designed to make sure that you)")
wxT(R"(have the freedom to distribute copies of free software (and charge for)")
wxT(R"(them if you wish), that you receive source code or can get it if you)")
wxT(R"(want it, that you can change the software or use pieces of it in new)")
wxT(R"(free programs, and that you know you can do these things.</p>)")
wxT(R"(<p>To protect your rights, we need to prevent others from denying you)")
wxT(R"(these rights or asking you to surrender the rights.  Therefore, you have)")
wxT(R"(certain responsibilities if you distribute copies of the software, or if)")
wxT(R"(you modify it: responsibilities to respect the freedom of others.</p>)")
wxT(R"(<p>For example, if you distribute copies of such a program, whether)")
wxT(R"(gratis or for a fee, you must pass on to the recipients the same)")
wxT(R"(freedoms that you received.  You must make sure that they, too, receive)")
wxT(R"(or can get the source code.  And you must show them these terms so they)")
wxT(R"(know their rights.</p>)")
wxT(R"(<p>Developers that use the GNU GPL protect your rights with two steps:)")
wxT(R"((1) assert copyright on the software, and (2) offer you this License)")
wxT(R"(giving you legal permission to copy, distribute and/or modify it.</p>)")
wxT(R"(<p>For the developers' and authors' protection, the GPL clearly explains)")
wxT(R"(that there is no warranty for this free software.  For both users' and)")
wxT(R"(authors' sake, the GPL requires that modified versions be marked as)")
wxT(R"(changed, so that their problems will not be attributed erroneously to)")
wxT(R"(authors of previous versions.</p>)")
wxT(R"(<p>Some devices are designed to deny users access to install or run)")
wxT(R"(modified versions of the software inside them, although the manufacturer)")
wxT(R"(can do so.  This is fundamentally incompatible with the aim of)")
wxT(R"(protecting users' freedom to change the software.  The systematic)")
wxT(R"(pattern of such abuse occurs in the area of products for individuals to)")
wxT(R"(use, which is precisely where it is most unacceptable.  Therefore, we)")
wxT(R"(have designed this version of the GPL to prohibit the practice for those)")
wxT(R"(products.  If such problems arise substantially in other domains, we)")
wxT(R"(stand ready to extend this provision to those domains in future versions)")
wxT(R"(of the GPL, as needed to protect the freedom of users.</p>)")
wxT(R"(<p>Finally, every program is threatened constantly by software patents.)")
wxT(R"(States should not allow patents to restrict development and use of)")
wxT(R"(software on general-purpose computers, but in those that do, we wish to)")
wxT(R"(avoid the special danger that patents applied to a free program could)")
wxT(R"(make it effectively proprietary.  To prevent this, the GPL assures that)")
wxT(R"(patents cannot be used to render the program non-free.</p>)")
wxT(R"(<p>The precise terms and conditions for copying, distribution and)")
wxT(R"(modification follow.</p>)")
wxT(R"(<h4 id="terms">TERMS AND CONDITIONS</h4>)")
wxT(R"(<h5 id="section0">0. Definitions.</h5>)")
wxT(R"(<p>&ldquo;This License&rdquo; refers to version 3 of the GNU General Public License.</p>)")
wxT(R"(<p>&ldquo;Copyright&rdquo; also means copyright-like laws that apply to other kinds of)")
wxT(R"(works, such as semiconductor masks.</p>)")
wxT(R"( )")
wxT(R"(<p>&ldquo;The Program&rdquo; refers to any copyrightable work licensed under this)")
wxT(R"(License.  Each licensee is addressed as &ldquo;you&rdquo;.  &ldquo;Licensees&rdquo; and)")
wxT(R"(&ldquo;recipients&rdquo; may be individuals or organizations.</p>)")
wxT(R"(<p>To &ldquo;modify&rdquo; a work means to copy from or adapt all or part of the work)")
wxT(R"(in a fashion requiring copyright permission, other than the making of an)")
wxT(R"(exact copy.  The resulting work is called a &ldquo;modified version&rdquo; of the)")
wxT(R"(earlier work or a work &ldquo;based on&rdquo; the earlier work.</p>)")
wxT(R"(<p>A &ldquo;covered work&rdquo; means either the unmodified Program or a work based)")
wxT(R"(on the Program.</p>)")
wxT(R"(<p>To &ldquo;propagate&rdquo; a work means to do anything with it that, without)")
wxT(R"(permission, would make you directly or secondarily liable for)")
wxT(R"(infringement under applicable copyright law, except executing it on a)")
wxT(R"(computer or modifying a private copy.  Propagation includes copying,)")
wxT(R"(distribution (with or without modification), making available to the)")
wxT(R"(public, and in some countries other activities as well.</p>)")
wxT(R"(<p>To &ldquo;convey&rdquo; a work means any kind of propagation that enables other)")
wxT(R"(parties to make or receive copies.  Mere interaction with a user through)")
wxT(R"(a computer network, with no transfer of a copy, is not conveying.</p>)")
wxT(R"(<p>An interactive user interface displays &ldquo;Appropriate Legal Notices&rdquo;)")
wxT(R"(to the extent that it includes a convenient and prominently visible)")
wxT(R"(feature that (1) displays an appropriate copyright notice, and (2))")
wxT(R"(tells the user that there is no warranty for the work (except to the)")
wxT(R"(extent that warranties are provided), that licensees may convey the)")
wxT(R"(work under this License, and how to view a copy of this License.  If)")
wxT(R"(the interface presents a list of user commands or options, such as a)")
wxT(R"(menu, a prominent item in the list meets this criterion.</p>)")
wxT(R"(<h5 id="section1">1. Source Code.</h5>)")
wxT(R"(<p>The &ldquo;source code&rdquo; for a work means the preferred form of the work)")
wxT(R"(for making modifications to it.  &ldquo;Object code&rdquo; means any non-source)")
wxT(R"(form of a work.</p>)")
wxT(R"(<p>A &ldquo;Standard Interface&rdquo; means an interface that either is an official)")
wxT(R"(standard defined by a recognized standards body, or, in the case of)")
wxT(R"(interfaces specified for a particular programming language, one that)")
wxT(R"(is widely used among developers working in that language.</p>)")
wxT(R"(<p>The &ldquo;System Libraries&rdquo; of an executable work include anything, other)")
wxT(R"(than the work as a whole, that (a) is included in the normal form of)")
wxT(R"(packaging a Major Component, but which is not part of that Major)")
wxT(R"(Component, and (b) serves only to enable use of the work with that)")
wxT(R"(Major Component, or to implement a Standard Interface for which an)")
wxT(R"(implementation is available to the public in source code form.  A)")
wxT(R"(&ldquo;Major Component&rdquo;, in this context, means a major essential component)")
wxT(R"((kernel, window system, and so on) of the specific operating system)")
wxT(R"((if any) on which the executable work runs, or a compiler used to)")
wxT(R"(produce the work, or an object code interpreter used to run it.</p>)")
wxT(R"(<p>The &ldquo;Corresponding Source&rdquo; for a work in object code form means all)")
wxT(R"(the source code needed to generate, install, and (for an executable)")
wxT(R"(work) run the object code and to modify the work, including scripts to)")
wxT(R"(control those activities.  However, it does not include the work's)")
wxT(R"(System Libraries, or general-purpose tools or generally available free)")
wxT(R"(programs which are used unmodified in performing those activities but)")
wxT(R"(which are not part of the work.  For example, Corresponding Source)")
wxT(R"(includes interface definition files associated with source files for)")
wxT(R"(the work, and the source code for shared libraries and dynamically)")
wxT(R"(linked subprograms that the work is specifically designed to require,)")
wxT(R"(such as by intimate data communication or control flow between those)")
wxT(R"(subprograms and other parts of the work.</p>)")
wxT(R"(<p>The Corresponding Source need not include anything that users)")
wxT(R"(can regenerate automatically from other parts of the Corresponding)")
wxT(R"(Source.</p>)")
wxT(R"(<p>The Corresponding Source for a work in source code form is that)")
wxT(R"(same work.</p>)")
wxT(R"(<h5 id="section2">2. Basic Permissions.</h5>)")
wxT(R"(<p>All rights granted under this License are granted for the term of)")
wxT(R"(copyright on the Program, and are irrevocable provided the stated)")
wxT(R"(conditions are met.  This License explicitly affirms your unlimited)")
wxT(R"(permission to run the unmodified Program.  The output from running a)")
wxT(R"(covered work is covered by this License only if the output, given its)")
wxT(R"(content, constitutes a covered work.  This License acknowledges your)")
wxT(R"(rights of fair use or other equivalent, as provided by copyright law.</p>)")
wxT(R"(<p>You may make, run and propagate covered works that you do not)")
wxT(R"(convey, without conditions so long as your license otherwise remains)")
wxT(R"(in force.  You may convey covered works to others for the sole purpose)")
wxT(R"(of having them make modifications exclusively for you, or provide you)")
wxT(R"(with facilities for running those works, provided that you comply with)")
wxT(R"(the terms of this License in conveying all material for which you do)")
wxT(R"(not control copyright.  Those thus making or running the covered works)")
wxT(R"(for you must do so exclusively on your behalf, under your direction)")
wxT(R"(and control, on terms that prohibit them from making any copies of)")
wxT(R"(your copyrighted material outside their relationship with you.</p>)")
wxT(R"(<p>Conveying under any other circumstances is permitted solely under)")
wxT(R"(the conditions stated below.  Sublicensing is not allowed; section 10)")
wxT(R"(makes it unnecessary.</p>)")
wxT(R"(<h5 id="section3">3. Protecting Users' Legal Rights From Anti-Circumvention Law.</h5>)")
wxT(R"(<p>No covered work shall be deemed part of an effective technological)")
wxT(R"(measure under any applicable law fulfilling obligations under article)")
wxT(R"(11 of the WIPO copyright treaty adopted on 20 December 1996, or)")
wxT(R"(similar laws prohibiting or restricting circumvention of such)")
wxT(R"(measures.</p>)")
wxT(R"(<p>When you convey a covered work, you waive any legal power to forbid)")
wxT(R"(circumvention of technological measures to the extent such circumvention)")
wxT(R"(is effected by exercising rights under this License with respect to)")
wxT(R"(the covered work, and you disclaim any intention to limit operation or)")
wxT(R"(modification of the work as a means of enforcing, against the work's)")
wxT(R"(users, your or third parties' legal rights to forbid circumvention of)")
wxT(R"(technological measures.</p>)")
wxT(R"(<h5 id="section4">4. Conveying Verbatim Copies.</h5>)")
wxT(R"(<p>You may convey verbatim copies of the Program's source code as you)")
wxT(R"(receive it, in any medium, provided that you conspicuously and)")
wxT(R"(appropriately publish on each copy an appropriate copyright notice;)")
wxT(R"(keep intact all notices stating that this License and any)")
wxT(R"(non-permissive terms added in accord with section 7 apply to the code;)")
wxT(R"(keep intact all notices of the absence of any warranty; and give all)")
wxT(R"(recipients a copy of this License along with the Program.</p>)")
wxT(R"(<p>You may charge any price or no price for each copy that you convey,)")
wxT(R"(and you may offer support or warranty protection for a fee.</p>)")
wxT(R"(<h5 id="section5">5. Conveying Modified Source Versions.</h5>)")
wxT(R"(<p>You may convey a work based on the Program, or the modifications to)")
wxT(R"(produce it from the Program, in the form of source code under the)")
wxT(R"(terms of section 4, provided that you also meet all of these conditions:</p>)")
wxT(R"(<p>)")
wxT(R"(<p>a) The work must carry prominent notices stating that you modified)")
wxT(R"(    it, and giving a relevant date.</p>)")
wxT(R"(<p>b) The work must carry prominent notices stating that it is)")
wxT(R"(    released under this License and any conditions added under section)")
wxT(R"(    7.  This requirement modifies the requirement in section 4 to)")
wxT(R"(    &ldquo;keep intact all notices&rdquo;.</p>)")
wxT(R"(<p>c) You must license the entire work, as a whole, under this)")
wxT(R"(    License to anyone who comes into possession of a copy.  This)")
wxT(R"(    License will therefore apply, along with any applicable section 7)")
wxT(R"(    additional terms, to the whole of the work, and all its parts,)")
wxT(R"(    regardless of how they are packaged.  This License gives no)")
wxT(R"(    permission to license the work in any other way, but it does not)")
wxT(R"(    invalidate such permission if you have separately received it.</p>)")
wxT(R"(<p>d) If the work has interactive user interfaces, each must display)")
wxT(R"(    Appropriate Legal Notices; however, if the Program has interactive)")
wxT(R"(    interfaces that do not display Appropriate Legal Notices, your)")
wxT(R"(    work need not make them do so.</p>)")
wxT(R"(</p>)")
wxT(R"(<p>A compilation of a covered work with other separate and independent)")
wxT(R"(works, which are not by their nature extensions of the covered work,)")
wxT(R"(and which are not combined with it such as to form a larger program,)")
wxT(R"(in or on a volume of a storage or distribution medium, is called an)")
wxT(R"(&ldquo;aggregate&rdquo; if the compilation and its resulting copyright are not)")
wxT(R"(used to limit the access or legal rights of the compilation's users)")
wxT(R"(beyond what the individual works permit.  Inclusion of a covered work)")
wxT(R"(in an aggregate does not cause this License to apply to the other)")
wxT(R"(parts of the aggregate.</p>)")
wxT(R"(<h5 id="section6">6. Conveying Non-Source Forms.</h5>)")
wxT(R"(<p>You may convey a covered work in object code form under the terms)")
wxT(R"(of sections 4 and 5, provided that you also convey the)")
wxT(R"(machine-readable Corresponding Source under the terms of this License,)")
wxT(R"(in one of these ways:</p>)")
wxT(R"(<p>)")
wxT(R"(<p>a) Convey the object code in, or embodied in, a physical product)")
wxT(R"(    (including a physical distribution medium), accompanied by the)")
wxT(R"(    Corresponding Source fixed on a durable physical medium)")
wxT(R"(    customarily used for software interchange.</p>)")
wxT(R"(<p>b) Convey the object code in, or embodied in, a physical product)")
wxT(R"(    (including a physical distribution medium), accompanied by a)")
wxT(R"(    written offer, valid for at least three years and valid for as)")
wxT(R"(    long as you offer spare parts or customer support for that product)")
wxT(R"(    model, to give anyone who possesses the object code either (1) a)")
wxT(R"(    copy of the Corresponding Source for all the software in the)")
wxT(R"(    product that is covered by this License, on a durable physical)")
wxT(R"(    medium customarily used for software interchange, for a price no)")
wxT(R"(    more than your reasonable cost of physically performing this)")
wxT(R"(    conveying of source, or (2) access to copy the)")
wxT(R"(    Corresponding Source from a network server at no charge.</p>)")
wxT(R"(<p>c) Convey individual copies of the object code with a copy of the)")
wxT(R"(    written offer to provide the Corresponding Source.  This)")
wxT(R"(    alternative is allowed only occasionally and noncommercially, and)")
wxT(R"(    only if you received the object code with such an offer, in accord)")
wxT(R"(    with subsection 6b.</p>)")
wxT(R"(<p>d) Convey the object code by offering access from a designated)")
wxT(R"(    place (gratis or for a charge), and offer equivalent access to the)")
wxT(R"(    Corresponding Source in the same way through the same place at no)")
wxT(R"(    further charge.  You need not require recipients to copy the)")
wxT(R"(    Corresponding Source along with the object code.  If the place to)")
wxT(R"(    copy the object code is a network server, the Corresponding Source)")
wxT(R"(    may be on a different server (operated by you or a third party))")
wxT(R"(    that supports equivalent copying facilities, provided you maintain)")
wxT(R"(    clear directions next to the object code saying where to find the)")
wxT(R"(    Corresponding Source.  Regardless of what server hosts the)")
wxT(R"(    Corresponding Source, you remain obligated to ensure that it is)")
wxT(R"(    available for as long as needed to satisfy these requirements.</p>)")
wxT(R"(<p>e) Convey the object code using peer-to-peer transmission, provided)")
wxT(R"(    you inform other peers where the object code and Corresponding)")
wxT(R"(    Source of the work are being offered to the general public at no)")
wxT(R"(    charge under subsection 6d.</p>)")
wxT(R"(</p>)")
wxT(R"(<p>A separable portion of the object code, whose source code is excluded)")
wxT(R"(from the Corresponding Source as a System Library, need not be)")
wxT(R"(included in conveying the object code work.</p>)")
wxT(R"(<p>A &ldquo;User Product&rdquo; is either (1) a &ldquo;consumer product&rdquo;, which means any)")
wxT(R"(tangible personal property which is normally used for personal, family,)")
wxT(R"(or household purposes, or (2) anything designed or sold for incorporation)")
wxT(R"(into a dwelling.  In determining whether a product is a consumer product,)")
wxT(R"(doubtful cases shall be resolved in favor of coverage.  For a particular)")
wxT(R"(product received by a particular user, &ldquo;normally used&rdquo; refers to a)")
wxT(R"(typical or common use of that class of product, regardless of the status)")
wxT(R"(of the particular user or of the way in which the particular user)")
wxT(R"(actually uses, or expects or is expected to use, the product.  A product)")
wxT(R"(is a consumer product regardless of whether the product has substantial)")
wxT(R"(commercial, industrial or non-consumer uses, unless such uses represent)")
wxT(R"(the only significant mode of use of the product.</p>)")
wxT(R"(<p>&ldquo;Installation Information&rdquo; for a User Product means any methods,)")
wxT(R"(procedures, authorization keys, or other information required to install)")
wxT(R"(and execute modified versions of a covered work in that User Product from)")
wxT(R"(a modified version of its Corresponding Source.  The information must)")
wxT(R"(suffice to ensure that the continued functioning of the modified object)")
wxT(R"(code is in no case prevented or interfered with solely because)")
wxT(R"(modification has been made.</p>)")
wxT(R"(<p>If you convey an object code work under this section in, or with, or)")
wxT(R"(specifically for use in, a User Product, and the conveying occurs as)")
wxT(R"(part of a transaction in which the right of possession and use of the)")
wxT(R"(User Product is transferred to the recipient in perpetuity or for a)")
wxT(R"(fixed term (regardless of how the transaction is characterized), the)")
wxT(R"(Corresponding Source conveyed under this section must be accompanied)")
wxT(R"(by the Installation Information.  But this requirement does not apply)")
wxT(R"(if neither you nor any third party retains the ability to install)")
wxT(R"(modified object code on the User Product (for example, the work has)")
wxT(R"(been installed in ROM).</p>)")
wxT(R"(<p>The requirement to provide Installation Information does not include a)")
wxT(R"(requirement to continue to provide support service, warranty, or updates)")
wxT(R"(for a work that has been modified or installed by the recipient, or for)")
wxT(R"(the User Product in which it has been modified or installed.  Access to a)")
wxT(R"(network may be denied when the modification itself materially and)")
wxT(R"(adversely affects the operation of the network or violates the rules and)")
wxT(R"(protocols for communication across the network.</p>)")
wxT(R"(<p>Corresponding Source conveyed, and Installation Information provided,)")
wxT(R"(in accord with this section must be in a format that is publicly)")
wxT(R"(documented (and with an implementation available to the public in)")
wxT(R"(source code form), and must require no special password or key for)")
wxT(R"(unpacking, reading or copying.</p>)")
wxT(R"(<h5 id="section7">7. Additional Terms.</h5>)")
wxT(R"(<p>&ldquo;Additional permissions&rdquo; are terms that supplement the terms of this)")
wxT(R"(License by making exceptions from one or more of its conditions.)")
wxT(R"(Additional permissions that are applicable to the entire Program shall)")
wxT(R"(be treated as though they were included in this License, to the extent)")
wxT(R"(that they are valid under applicable law.  If additional permissions)")
wxT(R"(apply only to part of the Program, that part may be used separately)")
wxT(R"(under those permissions, but the entire Program remains governed by)")
wxT(R"(this License without regard to the additional permissions.</p>)")
wxT(R"(<p>When you convey a copy of a covered work, you may at your option)")
wxT(R"(remove any additional permissions from that copy, or from any part of)")
wxT(R"(it.  (Additional permissions may be written to require their own)")
wxT(R"(removal in certain cases when you modify the work.)  You may place)")
wxT(R"(additional permissions on material, added by you to a covered work,)")
wxT(R"(for which you have or can give appropriate copyright permission.</p>)")
wxT(R"(<p>Notwithstanding any other provision of this License, for material you)")
wxT(R"(add to a covered work, you may (if authorized by the copyright holders of)")
wxT(R"(that material) supplement the terms of this License with terms:</p>)")
wxT(R"(<p>)")
wxT(R"(<p>a) Disclaiming warranty or limiting liability differently from the)")
wxT(R"(    terms of sections 15 and 16 of this License; or</p>)")
wxT(R"(<p>b) Requiring preservation of specified reasonable legal notices or)")
wxT(R"(    author attributions in that material or in the Appropriate Legal)")
wxT(R"(    Notices displayed by works containing it; or</p>)")
wxT(R"(<p>c) Prohibiting misrepresentation of the origin of that material, or)")
wxT(R"(    requiring that modified versions of such material be marked in)")
wxT(R"(    reasonable ways as different from the original version; or</p>)")
wxT(R"(<p>d) Limiting the use for publicity purposes of names of licensors or)")
wxT(R"(    authors of the material; or</p>)")
wxT(R"(<p>e) Declining to grant rights under trademark law for use of some)")
wxT(R"(    trade names, trademarks, or service marks; or</p>)")
wxT(R"(<p>f) Requiring indemnification of licensors and authors of that)")
wxT(R"(    material by anyone who conveys the material (or modified versions of)")
wxT(R"(    it) with contractual assumptions of liability to the recipient, for)")
wxT(R"(    any liability that these contractual assumptions directly impose on)")
wxT(R"(    those licensors and authors.</p>)")
wxT(R"(</p>)")
wxT(R"(<p>All other non-permissive additional terms are considered &ldquo;further)")
wxT(R"(restrictions&rdquo; within the meaning of section 10.  If the Program as you)")
wxT(R"(received it, or any part of it, contains a notice stating that it is)")
wxT(R"(governed by this License along with a term that is a further)")
wxT(R"(restriction, you may remove that term.  If a license document contains)")
wxT(R"(a further restriction but permits relicensing or conveying under this)")
wxT(R"(License, you may add to a covered work material governed by the terms)")
wxT(R"(of that license document, provided that the further restriction does)")
wxT(R"(not survive such relicensing or conveying.</p>)")
wxT(R"(<p>If you add terms to a covered work in accord with this section, you)")
wxT(R"(must place, in the relevant source files, a statement of the)")
wxT(R"(additional terms that apply to those files, or a notice indicating)")
wxT(R"(where to find the applicable terms.</p>)")
wxT(R"(<p>Additional terms, permissive or non-permissive, may be stated in the)")
wxT(R"(form of a separately written license, or stated as exceptions;)")
wxT(R"(the above requirements apply either way.</p>)")
wxT(R"(<h5 id="section8">8. Termination.</h5>)")
wxT(R"(<p>You may not propagate or modify a covered work except as expressly)")
wxT(R"(provided under this License.  Any attempt otherwise to propagate or)")
wxT(R"(modify it is void, and will automatically terminate your rights under)")
wxT(R"(this License (including any patent licenses granted under the third)")
wxT(R"(paragraph of section 11).</p>)")
wxT(R"(<p>However, if you cease all violation of this License, then your)")
wxT(R"(license from a particular copyright holder is reinstated (a))")
wxT(R"(provisionally, unless and until the copyright holder explicitly and)")
wxT(R"(finally terminates your license, and (b) permanently, if the copyright)")
wxT(R"(holder fails to notify you of the violation by some reasonable means)")
wxT(R"(prior to 60 days after the cessation.</p>)")
wxT(R"(<p>Moreover, your license from a particular copyright holder is)")
wxT(R"(reinstated permanently if the copyright holder notifies you of the)")
wxT(R"(violation by some reasonable means, this is the first time you have)")
wxT(R"(received notice of violation of this License (for any work) from that)")
wxT(R"(copyright holder, and you cure the violation prior to 30 days after)")
wxT(R"(your receipt of the notice.</p>)")
wxT(R"(<p>Termination of your rights under this section does not terminate the)")
wxT(R"(licenses of parties who have received copies or rights from you under)")
wxT(R"(this License.  If your rights have been terminated and not permanently)")
wxT(R"(reinstated, you do not qualify to receive new licenses for the same)")
wxT(R"(material under section 10.</p>)")
wxT(R"(<h5 id="section9">9. Acceptance Not Required for Having Copies.</h5>)")
wxT(R"(<p>You are not required to accept this License in order to receive or)")
wxT(R"(run a copy of the Program.  Ancillary propagation of a covered work)")
wxT(R"(occurring solely as a consequence of using peer-to-peer transmission)")
wxT(R"(to receive a copy likewise does not require acceptance.  However,)")
wxT(R"(nothing other than this License grants you permission to propagate or)")
wxT(R"(modify any covered work.  These actions infringe copyright if you do)")
wxT(R"(not accept this License.  Therefore, by modifying or propagating a)")
wxT(R"(covered work, you indicate your acceptance of this License to do so.</p>)")
wxT(R"(<h5 id="section10">10. Automatic Licensing of Downstream Recipients.</h5>)")
wxT(R"(<p>Each time you convey a covered work, the recipient automatically)")
wxT(R"(receives a license from the original licensors, to run, modify and)")
wxT(R"(propagate that work, subject to this License.  You are not responsible)")
wxT(R"(for enforcing compliance by third parties with this License.</p>)")
wxT(R"(<p>An &ldquo;entity transaction&rdquo; is a transaction transferring control of an)")
wxT(R"(organization, or substantially all assets of one, or subdividing an)")
wxT(R"(organization, or merging organizations.  If propagation of a covered)")
wxT(R"(work results from an entity transaction, each party to that)")
wxT(R"(transaction who receives a copy of the work also receives whatever)")
wxT(R"(licenses to the work the party's predecessor in interest had or could)")
wxT(R"(give under the previous paragraph, plus a right to possession of the)")
wxT(R"(Corresponding Source of the work from the predecessor in interest, if)")
wxT(R"(the predecessor has it or can get it with reasonable efforts.</p>)")
wxT(R"(<p>You may not impose any further restrictions on the exercise of the)")
wxT(R"(rights granted or affirmed under this License.  For example, you may)")
wxT(R"(not impose a license fee, royalty, or other charge for exercise of)")
wxT(R"(rights granted under this License, and you may not initiate litigation)")
wxT(R"((including a cross-claim or counterclaim in a lawsuit) alleging that)")
wxT(R"(any patent claim is infringed by making, using, selling, offering for)")
wxT(R"(sale, or importing the Program or any portion of it.</p>)")
wxT(R"(<h5 id="section11">11. Patents.</h5>)")
wxT(R"(<p>A &ldquo;contributor&rdquo; is a copyright holder who authorizes use under this)")
wxT(R"(License of the Program or a work on which the Program is based.  The)")
wxT(R"(work thus licensed is called the contributor's &ldquo;contributor version&rdquo;.</p>)")
wxT(R"(<p>A contributor's &ldquo;essential patent claims&rdquo; are all patent claims)")
wxT(R"(owned or controlled by the contributor, whether already acquired or)")
wxT(R"(hereafter acquired, that would be infringed by some manner, permitted)")
wxT(R"(by this License, of making, using, or selling its contributor version,)")
wxT(R"(but do not include claims that would be infringed only as a)")
wxT(R"(consequence of further modification of the contributor version.  For)")
wxT(R"(purposes of this definition, &ldquo;control&rdquo; includes the right to grant)")
wxT(R"(patent sublicenses in a manner consistent with the requirements of)")
wxT(R"(this License.</p>)")
wxT(R"(<p>Each contributor grants you a non-exclusive, worldwide, royalty-free)")
wxT(R"(patent license under the contributor's essential patent claims, to)")
wxT(R"(make, use, sell, offer for sale, import and otherwise run, modify and)")
wxT(R"(propagate the contents of its contributor version.</p>)")
wxT(R"(<p>In the following three paragraphs, a &ldquo;patent license&rdquo; is any express)")
wxT(R"(agreement or commitment, however denominated, not to enforce a patent)")
wxT(R"((such as an express permission to practice a patent or covenant not to)")
wxT(R"(sue for patent infringement).  To &ldquo;grant&rdquo; such a patent license to a)")
wxT(R"(party means to make such an agreement or commitment not to enforce a)")
wxT(R"(patent against the party.</p>)")
wxT(R"(<p>If you convey a covered work, knowingly relying on a patent license,)")
wxT(R"(and the Corresponding Source of the work is not available for anyone)")
wxT(R"(to copy, free of charge and under the terms of this License, through a)")
wxT(R"(publicly available network server or other readily accessible means,)")
wxT(R"(then you must either (1) cause the Corresponding Source to be so)")
wxT(R"(available, or (2) arrange to deprive yourself of the benefit of the)")
wxT(R"(patent license for this particular work, or (3) arrange, in a manner)")
wxT(R"(consistent with the requirements of this License, to extend the patent)")
wxT(R"(license to downstream recipients.  &ldquo;Knowingly relying&rdquo; means you have)")
wxT(R"(actual knowledge that, but for the patent license, your conveying the)")
wxT(R"(covered work in a country, or your recipient's use of the covered work)")
wxT(R"(in a country, would infringe one or more identifiable patents in that)")
wxT(R"(country that you have reason to believe are valid.</p>)")
wxT(R"(  )")
wxT(R"(<p>If, pursuant to or in connection with a single transaction or)")
wxT(R"(arrangement, you convey, or propagate by procuring conveyance of, a)")
wxT(R"(covered work, and grant a patent license to some of the parties)")
wxT(R"(receiving the covered work authorizing them to use, propagate, modify)")
wxT(R"(or convey a specific copy of the covered work, then the patent license)")
wxT(R"(you grant is automatically extended to all recipients of the covered)")
wxT(R"(work and works based on it.</p>)")
wxT(R"(<p>A patent license is &ldquo;discriminatory&rdquo; if it does not include within)")
wxT(R"(the scope of its coverage, prohibits the exercise of, or is)")
wxT(R"(conditioned on the non-exercise of one or more of the rights that are)")
wxT(R"(specifically granted under this License.  You may not convey a covered)")
wxT(R"(work if you are a party to an arrangement with a third party that is)")
wxT(R"(in the business of distributing software, under which you make payment)")
wxT(R"(to the third party based on the extent of your activity of conveying)")
wxT(R"(the work, and under which the third party grants, to any of the)")
wxT(R"(parties who would receive the covered work from you, a discriminatory)")
wxT(R"(patent license (a) in connection with copies of the covered work)")
wxT(R"(conveyed by you (or copies made from those copies), or (b) primarily)")
wxT(R"(for and in connection with specific products or compilations that)")
wxT(R"(contain the covered work, unless you entered into that arrangement,)")
wxT(R"(or that patent license was granted, prior to 28 March 2007.</p>)")
wxT(R"(<p>Nothing in this License shall be construed as excluding or limiting)")
wxT(R"(any implied license or other defenses to infringement that may)")
wxT(R"(otherwise be available to you under applicable patent law.</p>)")
wxT(R"(<h5 id="section12">12. No Surrender of Others' Freedom.</h5>)")
wxT(R"(<p>If conditions are imposed on you (whether by court order, agreement or)")
wxT(R"(otherwise) that contradict the conditions of this License, they do not)")
wxT(R"(excuse you from the conditions of this License.  If you cannot convey a)")
wxT(R"(covered work so as to satisfy simultaneously your obligations under this)")
wxT(R"(License and any other pertinent obligations, then as a consequence you may)")
wxT(R"(not convey it at all.  For example, if you agree to terms that obligate you)")
wxT(R"(to collect a royalty for further conveying from those to whom you convey)")
wxT(R"(the Program, the only way you could satisfy both those terms and this)")
wxT(R"(License would be to refrain entirely from conveying the Program.</p>)")
wxT(R"(<h5 id="section13">13. Use with the GNU Affero General Public License.</h5>)")
wxT(R"(<p>Notwithstanding any other provision of this License, you have)")
wxT(R"(permission to link or combine any covered work with a work licensed)")
wxT(R"(under version 3 of the GNU Affero General Public License into a single)")
wxT(R"(combined work, and to convey the resulting work.  The terms of this)")
wxT(R"(License will continue to apply to the part which is the covered work,)")
wxT(R"(but the special requirements of the GNU Affero General Public License,)")
wxT(R"(section 13, concerning interaction through a network will apply to the)")
wxT(R"(combination as such.</p>)")
wxT(R"(<h5 id="section14">14. Revised Versions of this License.</h5>)")
wxT(R"(<p>The Free Software Foundation may publish revised and/or new versions of)")
wxT(R"(the GNU General Public License from time to time.  Such new versions will)")
wxT(R"(be similar in spirit to the present version, but may differ in detail to)")
wxT(R"(address new problems or concerns.</p>)")
wxT(R"(<p>Each version is given a distinguishing version number.  If the)")
wxT(R"(Program specifies that a certain numbered version of the GNU General)")
wxT(R"(Public License &ldquo;or any later version&rdquo; applies to it, you have the)")
wxT(R"(option of following the terms and conditions either of that numbered)")
wxT(R"(version or of any later version published by the Free Software)")
wxT(R"(Foundation.  If the Program does not specify a version number of the)")
wxT(R"(GNU General Public License, you may choose any version ever published)")
wxT(R"(by the Free Software Foundation.</p>)")
wxT(R"(<p>If the Program specifies that a proxy can decide which future)")
wxT(R"(versions of the GNU General Public License can be used, that proxy's)")
wxT(R"(public statement of acceptance of a version permanently authorizes you)")
wxT(R"(to choose that version for the Program.</p>)")
wxT(R"(<p>Later license versions may give you additional or different)")
wxT(R"(permissions.  However, no additional obligations are imposed on any)")
wxT(R"(author or copyright holder as a result of your choosing to follow a)")
wxT(R"(later version.</p>)")
wxT(R"(<h5 id="section15">15. Disclaimer of Warranty.</h5>)")
wxT(R"(<p>THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY)")
wxT(R"(APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT)")
wxT(R"(HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM &ldquo;AS IS&rdquo; WITHOUT WARRANTY)")
wxT(R"(OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,)")
wxT(R"(THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR)")
wxT(R"(PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM)")
wxT(R"(IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF)")
wxT(R"(ALL NECESSARY SERVICING, REPAIR OR CORRECTION.</p>)")
wxT(R"(<h5 id="section16">16. Limitation of Liability.</h5>)")
wxT(R"(<p>IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING)")
wxT(R"(WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS)")
wxT(R"(THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY)")
wxT(R"(GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE)")
wxT(R"(USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF)")
wxT(R"(DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD)")
wxT(R"(PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),)")
wxT(R"(EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF)")
wxT(R"(SUCH DAMAGES.</p>)")
wxT(R"(<h5 id="section17">17. Interpretation of Sections 15 and 16.</h5>)")
wxT(R"(<p>If the disclaimer of warranty and limitation of liability provided)")
wxT(R"(above cannot be given local legal effect according to their terms,)")
wxT(R"(reviewing courts shall apply local law that most closely approximates)")
wxT(R"(an absolute waiver of all civil liability in connection with the)")
wxT(R"(Program, unless a warranty or assumption of liability accompanies a)")
wxT(R"(copy of the Program in return for a fee.</p>)");
}
